<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  creationComplete="creationCompleteHandler(event)" title="Cadastro de Atividade Atendido" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	<fx:Script source="../../../framework/util/util.as"/>
	
	<fx:Metadata>
		[Event(name="AtividadeAtendidoIncluidoEvent")]
		[Event(name="AtividadeAtendidoAtualizadoEvent")]
		[Event(name="AtividadeAtendidoExcluidoEvent")]
		[Event(name="AtividadeAtendidoSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import mx.collections.ArrayCollection;
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.validators.Validator;
			
			import br.com.desenv.nepalign.vo.AtividadeAtendido;
			
			import br.com.desenv.nepalign.vo.AtividadeOferecida;
			import br.com.desenv.nepalign.vo.Atendido;
			// Alguem passa a objeto para ca
			public var atividadeAtendido : AtividadeAtendido = new AtividadeAtendido();
			
			[Bindable]
			private var listaAtividadeOferecida: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaAtendido: ArrayCollection = new ArrayCollection();

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
// Lupa
				ignTextInputAtendido.text = "";
				ignTextInputAtendido.editable = false;
// Combo
				ignComboBoxAutoCompleteAtividadeOferecida.selectedIndex = -1;
				ignTextInputDateDataInicio.text = "";
				ignTextInputDateDataFim.text = "";
				ignComboBoxFixoPeriodoPreferencial.selectedIndex = -1;
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				var remoteObjectAtividadeOferecida: RemoteObject  = prepararObjetoRemoto("atividadeOferecidaService", listarAtividadeOferecidaResultHandler);	
				remoteObjectAtividadeOferecida.getOperation("listar").send();

				//Se o objeto foi enviado passamos o valor
				if (this.atividadeAtendido.atendido != null)
				{
					ignTextInputAtendido.text = atividadeAtendido.atendido.id + " - " + atividadeAtendido.atendido.nomeCompleto;
				}				
				// Se e um novo cadastro
				else if (this.atividadeAtendido.id == 0)
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{

					if (this.atividadeAtendido.atendido != null)
					{
						ignTextInputAtendido.text = atividadeAtendido.atendido.id + " - " + atividadeAtendido.atendido.nomeCompleto;
					}
					ignTextInputAtendido.editable = false;
					//ignComboBoxAutoCompleteAtividadeOferecida.selectedItem = this.atividadeAtendido.atividadeOferecida;
					ignTextInputDateDataInicio.text = DateField.dateToString(this.atividadeAtendido.dataInicio, "DD/MM/YYYY"); 

					ignTextInputDateDataFim.text = DateField.dateToString(this.atividadeAtendido.dataFim, "DD/MM/YYYY"); 

					for(var i:int = 0; i < this.listaOpcaoPeriodoPreferencial.length; i++)
					{
						if (this.listaOpcaoPeriodoPreferencial.getItemAt(i).codigo == this.atividadeAtendido.periodoPreferencial)
						{
							ignComboBoxFixoPeriodoPreferencial.selectedIndex = i;
							break;
						}
					}

				}
			}
			
			private function listarAtividadeOferecidaResultHandler( event: ResultEvent ): void 
			{
				listaAtividadeOferecida = event.result as ArrayCollection;
				listaAtividadeOferecida.addItemAt(null, 0);
				
				if (this.atividadeAtendido != null && this.atividadeAtendido.atividadeOferecida != null)
				{
					for(var i:int = 1; i <= this.listaAtividadeOferecida.length; i++)
					{
						var atividadeOferecidaTemp: AtividadeOferecida = this.listaAtividadeOferecida.getItemAt(i) as AtividadeOferecida;
						
						if (atividadeOferecidaTemp.id == this.atividadeAtendido.atividadeOferecida.id)
						{
							ignComboBoxAutoCompleteAtividadeOferecida.selectedIndex = i;
							break;
						}
					}
				}	
			}
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				PopUpManager.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (atividadeAtendido.id != 0) 
					{
						//atividadeAtendido.atendido = // Carregado via popup				
						atividadeAtendido.atividadeOferecida = ignComboBoxAutoCompleteAtividadeOferecida.selectedItem; 
						atividadeAtendido.dataInicio = ignTextInputDateDataInicio.text == ""?null:DateField.stringToDate(ignTextInputDateDataInicio.text, "DD/MM/YYYY");
						atividadeAtendido.dataFim = ignTextInputDateDataFim.text == ""?null:DateField.stringToDate(ignTextInputDateDataFim.text, "DD/MM/YYYY");
						atividadeAtendido.periodoPreferencial = ignComboBoxFixoPeriodoPreferencial.selectedItem==null?null:ignComboBoxFixoPeriodoPreferencial.selectedItem.codigo == ""?null:ignComboBoxFixoPeriodoPreferencial.selectedItem.codigo;
						var remoteObjectAtualizar: RemoteObject  = prepararObjetoRemoto("atividadeAtendidoService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(atividadeAtendido); 
					// Se e inclusao
					} 
					else 
					{
						atividadeAtendido.atividadeOferecida = ignComboBoxAutoCompleteAtividadeOferecida.selectedItem; 
						atividadeAtendido.dataInicio = ignTextInputDateDataInicio.text == ""?null:DateField.stringToDate(ignTextInputDateDataInicio.text, "DD/MM/YYYY");

						atividadeAtendido.dataFim = ignTextInputDateDataFim.text == ""?null:DateField.stringToDate(ignTextInputDateDataFim.text, "DD/MM/YYYY");

						atividadeAtendido.periodoPreferencial = ignComboBoxFixoPeriodoPreferencial.selectedItem==null?null:ignComboBoxFixoPeriodoPreferencial.selectedItem.codigo == ""?null:ignComboBoxFixoPeriodoPreferencial.selectedItem.codigo;

						var remoteObjectSalvar: RemoteObject  = prepararObjetoRemoto("atividadeAtendidoService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(atividadeAtendido); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.atividadeAtendido = event.result as AtividadeAtendido;
				this.dispatchEvent(new ResultEvent("AtividadeAtendidoIncluidoEvent",false, true, this.atividadeAtendido, null, null));
				PopUpManager.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.atividadeAtendido = event.result as AtividadeAtendido;
				this.dispatchEvent(new Event("AtividadeAtendidoAtualizadoEvent"));
				PopUpManager.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonAdicionarAtividadeOferecida_clickHandler(event:MouseEvent):void
			{
				var atividadeOferecidaComponenteCadastro: AtividadeOferecidaComponenteCadastro = new AtividadeOferecidaComponenteCadastro();
				atividadeOferecidaComponenteCadastro.addEventListener("AtividadeOferecidaIncluidoEvent", atualizarListaAtividadeOferecidaPorInclusaoResultHandler);
				PopUpManager.addPopUp(atividadeOferecidaComponenteCadastro, this, true);
				PopUpManager.centerPopUp(atividadeOferecidaComponenteCadastro);
			}
			
			private function atualizarListaAtividadeOferecidaPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoAtividadeOferecida: AtividadeOferecida = e.result as AtividadeOferecida;
				listaAtividadeOferecida.addItem(novoAtividadeOferecida);
				ignComboBoxAutoCompleteAtividadeOferecida.selectedItem = novoAtividadeOferecida;
			}
			protected function buttonPesquisarAtendido_clickHandler(event:MouseEvent):void
			{
				var atendidoComponentePesquisa: AtendidoComponentePesquisa = new AtendidoComponentePesquisa();
				atendidoComponentePesquisa.addEventListener("AtendidoSelecionadoEvent", atualizarAtendidoPorSelecaoResultHandler);
				PopUpManager.addPopUp(atendidoComponentePesquisa, this, true);
				PopUpManager.centerPopUp(atendidoComponentePesquisa);
			}
			
			private function atualizarAtendidoPorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoAtendido: Atendido = e.result as Atendido;
				ignTextInputAtendido.text = novoAtendido.id + " - " + novoAtendido.nomeCompleto;
				this.atividadeAtendido.atendido = novoAtendido;
			}

			protected function buttonAdicionarAtendido_clickHandler(event:MouseEvent):void
			{
				var atendidoComponenteCadastro: AtendidoComponenteCadastro = new AtendidoComponenteCadastro();
				atendidoComponenteCadastro.addEventListener("AtendidoIncluidoEvent", atualizarAtendidoPorInclusaoResultHandler);
				PopUpManager.addPopUp(atendidoComponenteCadastro, this, true);
				PopUpManager.centerPopUp(atendidoComponenteCadastro);
			}
			
			private function atualizarAtendidoPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoAtividadeAtendido: Atendido = e.result as Atendido;
				ignTextInputAtendido.text = novoAtividadeAtendido.id + " - " + novoAtividadeAtendido.nomeCompleto;
				this.atividadeAtendido.atendido = novoAtividadeAtendido;
			}

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoAtividadeAtendido" property="selectedItem" required="true" source="{comboBoxSituacaoAtividadeAtendido}" trigger="{comboBoxSituacaoAtividadeAtendido}" triggerEvent="valueCommit"/> -->
		
		<s:ArrayCollection id="listaOpcaoPeriodoPreferencial">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="M" valor="Manhã"/>
			<fx:Object codigo="T" valor="Tarde"/>
			<fx:Object codigo="N" valor="Noite"/>
			<fx:Object codigo="I" valor="Indiferente"/>
		</s:ArrayCollection>
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Atendido:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor" colSpan="3">
				<s:VGroup>
					<s:Label id="labelValidacaoAtendido" styleName="labelValidacao" text="{ignTextInputAtendido.errorString}"/>
					<s:HGroup>
						<visual:IgnTextInput id="ignTextInputAtendido" obrigatorio="true" width="250" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonPesquisarAtendido" width="30" label="..." click="buttonPesquisarAtendido_clickHandler(event)"/>
						<s:Button id="buttonAdicionarAtendido" width="30" label="+" click="buttonAdicionarAtendido_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Atividade:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoAtividadeOferecida" styleName="labelValidacao" text="{ignComboBoxAutoCompleteAtividadeOferecida.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteAtividadeOferecida" dataProvider="{listaAtividadeOferecida}" labelField="descricao" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarAtividadeOferecida" width="30" label="+" click="buttonAdicionarAtividadeOferecida_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Periodo Preferencial:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPeriodoPreferencial" styleName="labelValidacao" text="{ignComboBoxFixoPeriodoPreferencial.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoPeriodoPreferencial" obrigatorio="false"  dataProvider="{listaOpcaoPeriodoPreferencial}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data de Inicio:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataInicio" styleName="labelValidacao" text="{ignTextInputDateDataInicio.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataInicio" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Ultima participação:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataFim" styleName="labelValidacao" text="{ignTextInputDateDataFim.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataFim" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
					
		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>